<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\spare_part;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\spare_part\SparePart;
use app\common\lists\ListsSearchInterface;


/**
 * SparePart列表
 * Class SparePartLists
 * @package app\adminapi\lists
 */
class SparePartLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/09/14 15:08
     */
    public function setSearch(): array
    {
        return [
            '=' => ['spare_status'],
            'in' => ['goods_category_id'],
            '%like%' => ['spare_name']
        ];
    }
    public function queryWhere()
    {
        $where = [];
        if (!empty($this->params['goods_category_id'])) {
            $goodsCategoryId = end($this->params['goods_category_id']);
            $where[] = ['goods_category_id','=' ,$goodsCategoryId];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/09/14 15:08
     */
    public function lists(): array
    {
        return SparePart::with('goodsCategory')->where($this->searchWhere)
            ->where($this->queryWhere())
            ->field(['id', 'goods_category_id', 'spare_name', 'spare_image', 'spare_number', 'spare_unit', 'company_price', 'original_price', 'offering_price', 'spare_status'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/09/14 15:08
     */
    public function count(): int
    {
        return SparePart::where($this->searchWhere)->count();
    }

}